Subject: Re: [PATCH v2 net-next] net/mlx5e: Report rx_discards_phy via rx_fifo_errors

From: Jakub Kicinski <[email-masked]>
Date: Thu, 14 Nov 2024 20:32:56 -0800

On Fri, 15 Nov 2024 11:56:38 +0800 Yafang Shao wrote:
> > On Thu, 14 Nov 2024 10:17:11 +0800 Yafang Shao wrote:  
> > > - *   Not recommended for use in drivers for high speed interfaces.  
> >
> > I thought I suggested we provide clear guidance on this counter being
> > related to processing pipeline being to slow, vs host backpressure.
> > Just deleting the line that says "don't use" is not going to cut it :|  
> 
> Hello Jakub,
> 
> After investigating other network drivers, I found that they all
> report this metric to rx_missed_errors:
> 
> - i40e
>   The corresponding ethtool metric is port.rx_discards, which was
> mapped to rx_missed_errors in commit 5337d2949733 ("i40e: Add
> rx_missed_errors for buffer exhaustion").
> 
> - broadcom
>   The equivalent metric is rx_total_discard_pkts, reported as
> rx_missed_errors in commit c0c050c58d84 ("bnxt_en: New Broadcom
> ethernet driver")
> 
> Given this, it seems we should align with the standard practice and
> report this metric to rx_missed_errors.
> 
> Tariq, what are your thoughts?

mlx5 already reports rx_missed_errors and AFAIU rx_discards_phy are very
different kind of drops than the drops reported as 'missed'.
The distinction is useful in production in my experience working with
mlx5 devices.